---
title: ReportingObserver()
slug: Web/API/ReportingObserver/ReportingObserver
tags:
  - API
  - Constructor
  - Experimental
  - Reference
  - Reporting API
  - ReportingObserver
---
<div>{{APIRef("Reporting API")}}{{seecompattable}}</div>

<p>The <strong><code>ReportingObserver()</code></strong> constructor of the <a href="/en-US/docs/Web/API/Reporting_API">Reporting API</a> creates a new {{domxref("ReportingObserver")}} object instance, which can be used to collect and access reports.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">new ReportingObserver(<em>callback</em>[, <em>options</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>callback</code></dt>
 <dd>A callback function that runs when the observer starts to collect reports (i.e. via {{domxref("ReportingObserver.observe()")}}). The callback function is given two parameters:
 <ul>
  <li><code>reports</code>: A sequence of {{domxref("Report")}} objects representing the reports collected in the observer's report queue. This is probably the most common way to retrieve the reports.</li>
  <li><code>observer</code>: A reference to the same <code>ReportingObserver</code> object, allowing for recursive report collection, etc.</li>
 </ul>
 </dd>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>An {{domxref("ReportingObserverOptions")}} object allowing you to set the options for creating the object. The available options are:
 <ul>
  <li><code>types</code>: An array of strings representing the types of report to be collected by this observer. Available types include <code>deprecation</code>, <code>intervention</code>, and <code>crash</code> (although this last type usually isn't retrievable via a <code>ReportingObserver</code>).</li>
  <li><code>buffered</code>: a boolean that defines whether the reports that were generated before the observer was able to be created should be observable (<code>true</code>) or not (<code>false</code>).</li>
 </ul>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">let options = {
  types: ['deprecation'],
  buffered: true
}

let observer = new ReportingObserver(function(reports, observer) {
  reportBtn.onclick = () =&gt; displayReports(reports);
}, options);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Reporting API','#dom-reportingobserver-reportingobserver','ReportingObserver()')}}</td>
   <td>{{Spec2('Reporting API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ReportingObserver.ReportingObserver")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Reporting_API">Reporting API</a></li>
</ul>
